import { Component } from 'react';
import type { ViewProps } from '@instructure/ui-view';
import type { BaseButtonProps, BaseButtonStyleProps } from './props';
/**
---
category: components/utilities
---
**/
declare class BaseButton extends Component<BaseButtonProps> {
    static readonly componentId = "BaseButton";
    static propTypes: import("@instructure/shared-types").PropValidators<keyof import("./props").BaseButtonOwnProps>;
    static allowedProps: readonly (keyof import("./props").BaseButtonOwnProps)[];
    static defaultProps: {
        readonly type: "button";
        readonly size: "medium";
        readonly as: "button";
        readonly interaction: undefined;
        readonly color: "secondary";
        readonly shape: "rectangle";
        readonly display: "inline-block";
        readonly textAlign: "start";
        readonly withBackground: true;
        readonly withBorder: true;
        readonly isCondensed: false;
        readonly margin: "0";
        readonly cursor: "pointer";
    };
    ref: Element | null;
    componentDidMount(): void;
    componentDidUpdate(): void;
    get makeStylesVariables(): BaseButtonStyleProps;
    get hasOnlyIconVisible(): boolean;
    get elementType(): import("react").ComponentClass<any, any> | import("react").FunctionComponent<Readonly<BaseButtonProps>> | import("react").ComponentClass<Readonly<BaseButtonProps>, any> | NonNullable<import("@instructure/shared-types").AsElementType | undefined>;
    get interaction(): import("@instructure/ui-react-utils").InteractionType;
    get isDisabled(): boolean;
    get isReadOnly(): boolean;
    get isEnabled(): boolean;
    get focusColor(): "info" | "inverse";
    get focused(): boolean;
    focus(): void;
    handleElementRef: (el: Element | null) => void;
    handleClick: (event: React.MouseEvent<ViewProps & Element>) => void;
    handleKeyDown: (event: React.KeyboardEvent<ViewProps & Element>) => void;
    renderChildren(): import("@emotion/react/jsx-runtime").JSX.Element;
    render(): import("@emotion/react/jsx-runtime").JSX.Element;
}
export { BaseButton };
export default BaseButton;
//# sourceMappingURL=index.d.ts.map