import { Component } from 'react';
import { BaseButton } from '../BaseButton';
import type { ButtonProps } from './props';
/**
---
category: components
---
**/
declare class Button extends Component<ButtonProps> {
    static readonly componentId = "Button";
    static propTypes: import("@instructure/shared-types").PropValidators<keyof {
        children?: React.ReactNode;
        type?: "button" | "submit" | "reset";
        size?: "small" | "medium" | "large";
        elementRef?: (element: Element | null) => void;
        as?: import("@instructure/shared-types").AsElementType;
        interaction?: "enabled" | "disabled" | "readonly";
        color?: "primary" | "primary-inverse" | "secondary" | "success" | "danger" | "ai-primary" | "ai-secondary";
        focusColor?: "info" | "inverse";
        display?: "inline-block" | "block";
        textAlign?: "start" | "center";
        withBackground?: boolean;
        margin?: import("@instructure/emotion").Spacing;
        cursor?: import("@instructure/ui-prop-types").Cursor;
        href?: string;
        renderIcon?: React.ReactNode | (() => React.ReactNode);
        onClick?: (event: React.KeyboardEvent<import("@instructure/ui-view").ViewProps> | React.MouseEvent<import("@instructure/ui-view").ViewProps>) => void;
    }>;
    static allowedProps: readonly (keyof {
        children?: React.ReactNode;
        type?: "button" | "submit" | "reset";
        size?: "small" | "medium" | "large";
        elementRef?: (element: Element | null) => void;
        as?: import("@instructure/shared-types").AsElementType;
        interaction?: "enabled" | "disabled" | "readonly";
        color?: "primary" | "primary-inverse" | "secondary" | "success" | "danger" | "ai-primary" | "ai-secondary";
        focusColor?: "info" | "inverse";
        display?: "inline-block" | "block";
        textAlign?: "start" | "center";
        withBackground?: boolean;
        margin?: import("@instructure/emotion").Spacing;
        cursor?: import("@instructure/ui-prop-types").Cursor;
        href?: string;
        renderIcon?: React.ReactNode | (() => React.ReactNode);
        onClick?: (event: React.KeyboardEvent<import("@instructure/ui-view").ViewProps> | React.MouseEvent<import("@instructure/ui-view").ViewProps>) => void;
    })[];
    static defaultProps: {
        type: string;
        size: string;
        as: string;
        interaction: undefined;
        color: string;
        display: string;
        textAlign: string;
        withBackground: boolean;
        margin: string;
        cursor: string;
    };
    _buttonComponent: BaseButton | null;
    ref: Element | null;
    get focused(): boolean | null;
    focus(): void;
    handleElementRef: (el: Element | null) => void;
    handleButtonRef: (component: BaseButton | null) => void;
    render(): import("@emotion/react/jsx-runtime").JSX.Element;
}
export default Button;
export { Button };
//# sourceMappingURL=index.d.ts.map