import { Component } from 'react';
import type { CloseButtonProps } from './props';
/**
---
category: components
---
**/
declare class CloseButton extends Component<CloseButtonProps> {
    static readonly componentId = "CloseButton";
    static propTypes: import("@instructure/shared-types").PropValidators<keyof {
        screenReaderLabel: React.ReactNode;
        color?: "primary" | "primary-inverse";
        interaction?: "enabled" | "disabled" | "readonly";
        elementRef?: (element: Element | null) => void;
        size?: "small" | "medium" | "large";
        onClick?: (event: React.KeyboardEvent<import("@instructure/ui-view").ViewProps> | React.MouseEvent<import("@instructure/ui-view").ViewProps>) => void;
        margin?: import("@instructure/emotion").Spacing;
        placement?: "start" | "end" | "static";
        offset?: "none" | "x-small" | "small" | "medium";
        type?: "button" | "submit" | "reset";
        as?: import("@instructure/shared-types").AsElementType;
        href?: string;
        cursor?: import("@instructure/ui-prop-types").Cursor;
        tabIndex?: number;
    }>;
    static allowedProps: readonly (keyof {
        screenReaderLabel: React.ReactNode;
        color?: "primary" | "primary-inverse";
        interaction?: "enabled" | "disabled" | "readonly";
        elementRef?: (element: Element | null) => void;
        size?: "small" | "medium" | "large";
        onClick?: (event: React.KeyboardEvent<import("@instructure/ui-view").ViewProps> | React.MouseEvent<import("@instructure/ui-view").ViewProps>) => void;
        margin?: import("@instructure/emotion").Spacing;
        placement?: "start" | "end" | "static";
        offset?: "none" | "x-small" | "small" | "medium";
        type?: "button" | "submit" | "reset";
        as?: import("@instructure/shared-types").AsElementType;
        href?: string;
        cursor?: import("@instructure/ui-prop-types").Cursor;
        tabIndex?: number;
    })[];
    static defaultProps: {
        interaction: undefined;
        type: string;
        placement: string;
        offset: string;
        size: string;
        margin: string;
        as: string;
        cursor: string;
    };
    ref: Element | null;
    handleRef: (el: Element | null) => void;
    componentDidMount(): void;
    componentDidUpdate(): void;
    get interaction(): import("@instructure/ui-react-utils").InteractionType;
    get color(): "primary-inverse" | "secondary" | undefined;
    render(): import("@emotion/react/jsx-runtime").JSX.Element;
}
export default CloseButton;
export { CloseButton };
//# sourceMappingURL=index.d.ts.map