import { Component } from 'react';
import { BaseButton } from '../BaseButton';
import type { CondensedButtonProps } from './props';
/**
---
category: components
---
**/
declare class CondensedButton extends Component<CondensedButtonProps> {
    static readonly componentId = "CondensedButton";
    static propTypes: import("@instructure/shared-types").PropValidators<keyof {
        children?: React.ReactNode;
        type?: "button" | "submit" | "reset";
        size?: "small" | "medium" | "large";
        elementRef?: (element: Element | null) => void;
        as?: import("@instructure/shared-types").AsElementType;
        interaction?: "enabled" | "disabled" | "readonly";
        color?: "primary" | "primary-inverse" | "secondary";
        margin?: import("@instructure/emotion").Spacing;
        cursor?: import("@instructure/ui-prop-types").Cursor;
        href?: string;
        renderIcon?: React.ReactNode | (() => React.ReactNode);
        onClick?: (event: React.KeyboardEvent<import("@instructure/ui-view").ViewProps> | React.MouseEvent<import("@instructure/ui-view").ViewProps>) => void;
    }>;
    static allowedProps: readonly (keyof {
        children?: React.ReactNode;
        type?: "button" | "submit" | "reset";
        size?: "small" | "medium" | "large";
        elementRef?: (element: Element | null) => void;
        as?: import("@instructure/shared-types").AsElementType;
        interaction?: "enabled" | "disabled" | "readonly";
        color?: "primary" | "primary-inverse" | "secondary";
        margin?: import("@instructure/emotion").Spacing;
        cursor?: import("@instructure/ui-prop-types").Cursor;
        href?: string;
        renderIcon?: React.ReactNode | (() => React.ReactNode);
        onClick?: (event: React.KeyboardEvent<import("@instructure/ui-view").ViewProps> | React.MouseEvent<import("@instructure/ui-view").ViewProps>) => void;
    })[];
    static defaultProps: {
        type: string;
        size: string;
        as: string;
        interaction: undefined;
        color: string;
        margin: string;
        cursor: string;
    };
    _baseButton: BaseButton | null;
    ref: Element | null;
    handleRef: (el: Element | null) => void;
    get focused(): boolean | null;
    focus(): void;
    render(): import("@emotion/react/jsx-runtime").JSX.Element;
}
export default CondensedButton;
export { CondensedButton };
//# sourceMappingURL=index.d.ts.map