import { Component } from 'react';
import { BaseButton } from '../BaseButton';
import type { IconButtonProps } from './props';
/**
---
category: components
---
**/
declare class IconButton extends Component<IconButtonProps> {
    static readonly componentId = "IconButton";
    static propTypes: import("@instructure/shared-types").PropValidators<keyof {
        children?: import("@instructure/shared-types").Renderable;
        renderIcon?: import("@instructure/shared-types").Renderable;
        screenReaderLabel: import("react").ReactNode;
        type?: "button" | "submit" | "reset";
        size?: "small" | "medium" | "large";
        elementRef?: (element: Element | null) => void;
        as?: import("@instructure/shared-types").AsElementType;
        interaction?: "enabled" | "disabled" | "readonly";
        color?: "primary" | "primary-inverse" | "secondary" | "success" | "danger" | "ai-primary" | "ai-secondary";
        focusColor?: "info" | "inverse";
        shape?: "rectangle" | "circle";
        withBackground?: boolean;
        withBorder?: boolean;
        margin?: import("@instructure/emotion").Spacing;
        cursor?: import("@instructure/ui-prop-types").Cursor;
        href?: string;
        onClick?: (event: React.KeyboardEvent<import("@instructure/ui-view").ViewProps> | React.MouseEvent<import("@instructure/ui-view").ViewProps>) => void;
    }>;
    static allowedProps: readonly (keyof {
        children?: import("@instructure/shared-types").Renderable;
        renderIcon?: import("@instructure/shared-types").Renderable;
        screenReaderLabel: import("react").ReactNode;
        type?: "button" | "submit" | "reset";
        size?: "small" | "medium" | "large";
        elementRef?: (element: Element | null) => void;
        as?: import("@instructure/shared-types").AsElementType;
        interaction?: "enabled" | "disabled" | "readonly";
        color?: "primary" | "primary-inverse" | "secondary" | "success" | "danger" | "ai-primary" | "ai-secondary";
        focusColor?: "info" | "inverse";
        shape?: "rectangle" | "circle";
        withBackground?: boolean;
        withBorder?: boolean;
        margin?: import("@instructure/emotion").Spacing;
        cursor?: import("@instructure/ui-prop-types").Cursor;
        href?: string;
        onClick?: (event: React.KeyboardEvent<import("@instructure/ui-view").ViewProps> | React.MouseEvent<import("@instructure/ui-view").ViewProps>) => void;
    })[];
    static defaultProps: {
        type: string;
        size: string;
        as: string;
        interaction: undefined;
        color: string;
        shape: string;
        withBackground: boolean;
        withBorder: boolean;
        margin: string;
        cursor: string;
    };
    _baseButton: BaseButton | null;
    ref: Element | null;
    handleRef: (el: Element | null) => void;
    get focused(): boolean | null;
    focus(): void;
    render(): import("@emotion/react/jsx-runtime").JSX.Element;
}
export default IconButton;
export { IconButton };
//# sourceMappingURL=index.d.ts.map