import { Component } from 'react';
import type { ToggleButtonProps, ToggleButtonState } from './props';
/**
---
category: components
---
**/
declare class ToggleButton extends Component<ToggleButtonProps, ToggleButtonState> {
    static readonly componentId = "ToggleButton";
    static propTypes: import("@instructure/shared-types").PropValidators<keyof {
        screenReaderLabel: string;
        renderTooltipContent: React.ReactNode | ((...args: any[]) => any);
        renderIcon: import("@instructure/shared-types").Renderable;
        status: "pressed" | "unpressed";
        as?: import("@instructure/shared-types").AsElementType;
        interaction?: "enabled" | "disabled" | "readonly";
        size?: "small" | "medium" | "large";
        elementRef?: (element: Element | null) => void;
        onClick?: (event: React.KeyboardEvent<import("@instructure/ui-view").ViewProps> | React.MouseEvent<import("@instructure/ui-view").ViewProps>) => void;
        color?: "primary" | "primary-inverse" | "secondary" | "success" | "danger";
        isShowingTooltip?: boolean;
        mountNode?: import("@instructure/ui-position").PositionMountNode;
        placement?: import("@instructure/ui-position").PlacementPropValues;
        constrain?: import("@instructure/ui-position").PositionConstraint;
    }>;
    static allowedProps: readonly (keyof {
        screenReaderLabel: string;
        renderTooltipContent: React.ReactNode | ((...args: any[]) => any);
        renderIcon: import("@instructure/shared-types").Renderable;
        status: "pressed" | "unpressed";
        as?: import("@instructure/shared-types").AsElementType;
        interaction?: "enabled" | "disabled" | "readonly";
        size?: "small" | "medium" | "large";
        elementRef?: (element: Element | null) => void;
        onClick?: (event: React.KeyboardEvent<import("@instructure/ui-view").ViewProps> | React.MouseEvent<import("@instructure/ui-view").ViewProps>) => void;
        color?: "primary" | "primary-inverse" | "secondary" | "success" | "danger";
        isShowingTooltip?: boolean;
        mountNode?: import("@instructure/ui-position").PositionMountNode;
        placement?: import("@instructure/ui-position").PlacementPropValues;
        constrain?: import("@instructure/ui-position").PositionConstraint;
    })[];
    static defaultProps: {
        size: string;
        as: string;
        interaction: undefined;
        mountNode: null;
        color: string;
        placement: string;
        constrain: string;
    };
    constructor(props: ToggleButtonProps);
    ref: Element | null;
    handleRef: (el: Element | null) => void;
    get isShowingTooltip(): boolean;
    render(): import("@emotion/react/jsx-runtime").JSX.Element;
}
export { ToggleButton };
export default ToggleButton;
//# sourceMappingURL=index.d.ts.map